DECLARE FUNCTION MakeOrderInNum$ (num$, sep$)
DECLARE SUB DiskInfo (dl$, DiskFree#, DiskSpace#)
DECLARE FUNCTION Hex2Dec# (Hexa$)
DECLARE FUNCTION Hex2Bin$ (Hexadec$)
DECLARE FUNCTION Bin2Dec# (binarni$)
DECLARE FUNCTION int2hex$ (intgr%)

CLS

drive$ = "c"
DiskInfo drive$, DiskFree#, DiskSpace#

'get the KB's ab MB's of the disk...
DiskFreeKB# = DiskFree# \ 1024
DiskFreeMB# = DiskFree# \ 1024 \ 1024
DiskSpaceKB# = DiskSpace# \ 1024
DiskSpaceMB# = DiskSpace# \ 1024 \ 1024

'Convert them to string so we have a better look...
DiskFree$ = MakeOrderInNum$(STR$(DiskFree#), ",")
DiskSpace$ = MakeOrderInNum$(STR$(DiskSpace#), ",")
DiskFreeKB$ = MakeOrderInNum$(STR$(DiskFreeKB#), ",")
DiskSpaceKB$ = MakeOrderInNum$(STR$(DiskSpaceKB#), ",")
DiskFreeMB$ = MakeOrderInNum$(STR$(DiskFreeMB#), ",")
DiskSpaceMB$ = MakeOrderInNum$(STR$(DiskSpaceMB#), ",")

DiskFree$ = SPACE$(13 - LEN(DiskFree$)) + DiskFree$
DiskSpace$ = SPACE$(13 - LEN(DiskSpace$)) + DiskSpace$
DiskFreeKB$ = SPACE$(13 - LEN(DiskFreeKB$)) + DiskFreeKB$
DiskSpaceKB$ = SPACE$(13 - LEN(DiskSpaceKB$)) + DiskSpaceKB$
DiskFreeMB$ = SPACE$(13 - LEN(DiskFreeMB$)) + DiskFreeMB$
DiskSpaceMB$ = SPACE$(13 - LEN(DiskSpaceMB$)) + DiskSpaceMB$

drive$ = UCASE$(drive$)
PRINT "Drive "; drive$; " Info:"
PRINT
PRINT DiskFree$, "bytes free"
PRINT DiskFreeKB$, "Kbytes free"
PRINT DiskFreeMB$, "Mbytes free"
PRINT
PRINT DiskSpace$, "bytes total disk space"
PRINT DiskSpaceKB$, "Kbytes total disk space"
PRINT DiskSpaceMB$, "Mbytes total disk space"

FUNCTION Bin2Dec# (binarni$)
zbroji# = 1
FOR a = LEN(binarni$) TO 1 STEP -1
        b$ = MID$(binarni$, a, 1)
        IF b$ <> "0" THEN Decimalni# = Decimalni# + zbroji#
        zbroji# = zbroji# * 2
NEXT
Bin2Dec# = Decimalni#
END FUNCTION

' dl$           Drive for wich getting info (A,B,C...)
' DiskFree#     Disk free space in bytes (it's a DOUBLE because that are BIG
'               numbers)
' DiskSpace#    Total disk space in bytes (same thing like DiskFree#)
'
SUB DiskInfo (dl$, DiskFree#, DiskSpace#)

'convert the drive name into a number because the proc needs a num, not string...
dl$ = UCASE$(MID$(dl$, 1, 1))
dl% = ASC(dl$) - 64

'set the ASM code...
asm$ = "5589E5B436B2" + int2hex$(dl%) + "CD218B7E0C89058B7E0A891D8B7E08890D8B7E0689155DCB"
a$ = ""
FOR a = 1 TO LEN(asm$) STEP 2
     b$ = MID$(asm$, a, 2)
   
     b$ = CHR$(VAL("&H" + b$))
     a$ = a$ + b$
NEXT
asm$ = a$

'... and now call the ASM proc...
DEF SEG = VARSEG(asm$)
     CALL ABSOLUTE(ax%, bx%, cx%, dx%, SADD(asm$))
DEF SEG
IF HEX$(ax%) = "FFFF" THEN EXIT SUB  'invalid drive specification error

'We're converting it to hex and then back to decimal because if there are
'two 'FF's on hte beginning of the HEX code, if it's a signed number,
'would mean the number's negative - and it's signed...

DiskFree# = Hex2Dec#(HEX$(ax%)) * Hex2Dec#(HEX$(bx%)) * Hex2Dec#(HEX$(cx%))
DiskSpace# = Hex2Dec#(HEX$(ax%)) * Hex2Dec#(HEX$(cx%)) * Hex2Dec#(HEX$(dx%))
END SUB

FUNCTION Hex2Bin$ (Hexadec$)
FOR a = 1 TO LEN(Hexadec$)
        b$ = UCASE$(MID$(Hexadec$, a, 1))
                IF b$ = "0" THEN Binar$ = Binar$ + "0000"
                IF b$ = "1" THEN Binar$ = Binar$ + "0001"
                IF b$ = "2" THEN Binar$ = Binar$ + "0010"
                IF b$ = "3" THEN Binar$ = Binar$ + "0011"
                IF b$ = "4" THEN Binar$ = Binar$ + "0100"
                IF b$ = "5" THEN Binar$ = Binar$ + "0101"
                IF b$ = "6" THEN Binar$ = Binar$ + "0110"
                IF b$ = "7" THEN Binar$ = Binar$ + "0111"
                IF b$ = "8" THEN Binar$ = Binar$ + "1000"
                IF b$ = "9" THEN Binar$ = Binar$ + "1001"
                IF b$ = "A" THEN Binar$ = Binar$ + "1010"
                IF b$ = "B" THEN Binar$ = Binar$ + "1011"
                IF b$ = "C" THEN Binar$ = Binar$ + "1100"
                IF b$ = "D" THEN Binar$ = Binar$ + "1101"
                IF b$ = "E" THEN Binar$ = Binar$ + "1110"
                IF b$ = "F" THEN Binar$ = Binar$ + "1111"
NEXT
Hex2Bin$ = Binar$
END FUNCTION

FUNCTION Hex2Dec# (Hexa$)
Hex2Dec# = Bin2Dec#(Hex2Bin$(Hexa$))
END FUNCTION

FUNCTION int2hex$ (intgr%)
h$ = HEX$(intgr%)
IF LEN(h$) = 1 THEN h$ = "0" + h$
int2hex$ = h$
END FUNCTION

FUNCTION MakeOrderInNum$ (num$, sep$)
num$ = LTRIM$(RTRIM$(num$))
 FOR a = LEN(num$) TO 1 STEP -3
        b$ = MID$(num$, a + 1)
        num$ = MID$(num$, 1, a)
        num$ = num$ + sep$ + b$
 NEXT
num$ = LEFT$(num$, LEN(num$) - 1)
MakeOrderInNum$ = num$
END FUNCTION

